var Me = Object.defineProperty;
var He = (r, e, t) => e in r ? Me(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t;
var P = (r, e, t) => (He(r, typeof e != "symbol" ? e + "" : e, t), t);
import Se, { spawnSync as Ke } from "node:child_process";
import { constants as z, lstat as Z, mkdir as Fe, chmod as We, writeFile as Ne, unlink as Ve } from "node:fs/promises";
import { join as Ie, resolve as Ae } from "node:path";
import { randomBytes as Je } from "node:crypto";
const x = globalThis.process ?? { env: {}, versions: {} }, F = { ...x == null ? void 0 : x.env }, Xe = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...x == null ? void 0 : x.versions
}, qe = (x == null ? void 0 : x.platform) ?? "unknown", J = (x == null ? void 0 : x.arch) ?? "unknown";
class d extends Error {
  constructor(t, s) {
    super(t);
    P(this, "code");
    P(this, "stack");
    P(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack);
  }
}
const Qe = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], Ye = "browserstack-client", Ze = "3.0.0-next.10", et = "BrowserStack APIs client library for node.js", tt = "module", st = "./dist/browserstack-client.umd.cjs", rt = "./dist/browserstack-client.js", at = "./dist/types/index.d.ts", nt = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/node/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.umd.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, it = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs"
}, ot = "Shirish Kamath", ut = "MIT", pt = [
  "dist/**/*",
  "*.d.ts"
], ct = {
  node: ">=18.0.0"
}, lt = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.6",
  "@typescript-eslint/eslint-plugin": "^6.19.1",
  "@typescript-eslint/parser": "^6.19.1",
  "@vitest/coverage-v8": "^1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.5",
  typedoc: "^0.25.7",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.0",
  typescript: "^5.2.2",
  vite: "^5.0.8",
  "vite-plugin-dts": "^3.7.2",
  vitepress: "^1.0.0-rc.40",
  vitest: "1.2.1"
}, mt = {
  fflate: "^0.8.1",
  "openapi-fetch": "^0.8.2"
}, dt = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, ht = "https://shirish87.github.io/browserstack-client/", ft = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, wt = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], A = {
  name: Ye,
  version: Ze,
  description: et,
  type: tt,
  main: st,
  module: rt,
  types: at,
  exports: nt,
  scripts: it,
  author: ot,
  license: ut,
  files: pt,
  engines: ct,
  devDependencies: lt,
  dependencies: mt,
  repository: dt,
  homepage: ht,
  bugs: ft,
  keywords: wt
}, gt = [A == null ? void 0 : A.name, A == null ? void 0 : A.version].filter(Boolean).join("/"), vt = ["node", Xe.node].filter(Boolean).join("/"), kt = [gt, vt].filter(Boolean).join(" "), yt = {
  name: A == null ? void 0 : A.name,
  version: A == null ? void 0 : A.version,
  userAgent: kt
}, Rt = {
  "Content-Type": "application/json"
};
function be(r) {
  const {
    fetch: e = globalThis.fetch,
    querySerializer: t,
    bodySerializer: s,
    ...a
  } = r ?? {};
  let n = a.baseUrl ?? "";
  n.endsWith("/") && (n = n.slice(0, -1));
  async function o(u, p) {
    const {
      fetch: l = e,
      headers: m,
      body: i,
      params: c = {},
      parseAs: f = "json",
      querySerializer: k = t ?? St,
      bodySerializer: q = s ?? qt,
      ...v
    } = p || {}, R = bt(u, {
      baseUrl: n,
      params: c,
      querySerializer: k
    }), S = jt(
      Rt,
      r == null ? void 0 : r.headers,
      m,
      c.header
    ), g = {
      redirect: "follow",
      ...a,
      ...v,
      headers: S
    };
    i && (g.body = q(i)), g.body instanceof FormData && S.delete("Content-Type");
    const w = await l(R, g);
    if (w.status === 204 || w.headers.get("Content-Length") === "0")
      return w.ok ? { data: {}, response: w } : { error: {}, response: w };
    if (w.ok) {
      if (f === "stream")
        return { data: w.clone().body, response: w };
      const y = w.clone();
      return {
        data: typeof y[f] == "function" ? await y[f]() : await y.text(),
        response: w
      };
    }
    let T = {};
    try {
      T = await w.clone().json();
    } catch {
      T = await w.clone().text();
    }
    return { error: T, response: w };
  }
  return {
    /** Call a GET endpoint */
    async GET(u, p) {
      return o(u, { ...p, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(u, p) {
      return o(u, { ...p, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(u, p) {
      return o(u, { ...p, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(u, p) {
      return o(u, { ...p, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(u, p) {
      return o(u, { ...p, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(u, p) {
      return o(u, { ...p, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(u, p) {
      return o(u, { ...p, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(u, p) {
      return o(u, { ...p, method: "TRACE" });
    }
  };
}
function St(r) {
  const e = [];
  if (r && typeof r == "object")
    for (const [t, s] of Object.entries(r)) {
      const a = ue([t], s);
      a && e.push(a);
    }
  return e.join("&");
}
function ue(r, e) {
  if (e != null) {
    if (typeof e == "string")
      return `${ae(r)}=${encodeURIComponent(e)}`;
    if (typeof e == "number" || typeof e == "boolean")
      return `${ae(r)}=${String(e)}`;
    if (Array.isArray(e)) {
      if (!e.length)
        return;
      const t = [];
      for (const s of e) {
        const a = ue(r, s);
        a !== void 0 && t.push(a);
      }
      return t.join("&");
    }
    if (typeof e == "object") {
      if (!Object.keys(e).length)
        return;
      const t = [];
      for (const [s, a] of Object.entries(e))
        if (a != null) {
          const n = ue([...r, s], a);
          n !== void 0 && t.push(n);
        }
      return t.join("&");
    }
    return encodeURIComponent(`${ae(r)}=${String(e)}`);
  }
}
function ae(r) {
  let e = r[0];
  for (const t of r.slice(1))
    e += `[${t}]`;
  return e;
}
function qt(r) {
  return JSON.stringify(r);
}
function bt(r, e) {
  let t = `${e.baseUrl}${r}`;
  if (e.params.path)
    for (const [a, n] of Object.entries(e.params.path))
      t = t.replace(`{${a}}`, encodeURIComponent(String(n)));
  const s = e.querySerializer(e.params.query ?? {});
  return s && (t += `?${s}`), t;
}
function jt(...r) {
  const e = new Headers();
  for (const t of r) {
    if (!t || typeof t != "object")
      continue;
    const s = t instanceof Headers ? t.entries() : Object.entries(t);
    for (const [a, n] of s)
      n === null ? e.delete(a) : n !== void 0 && e.set(a, n);
  }
  return e;
}
const [{ variables: X }, { variables: Q }] = Qe ?? [], It = `${X.scheme.default}://${X.host.default}${X.basePath ? X.basePath.default : ""}`, At = `${Q.scheme.default}://${Q.host.default}${Q.basePath ? Q.basePath.default : ""}`;
class W {
  constructor(e) {
    P(this, "sdk");
    P(this, "sdkCloud");
    const t = e.username ?? F.BROWSERSTACK_USERNAME;
    if (e.usernameOptional !== !0 && (typeof t != "string" || !t.trim().length))
      throw new d("Missing options.username");
    const s = e.key ?? F.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new d("Missing options.key");
    const a = {
      ...e,
      baseUrl: e.baseUrl ?? It,
      headers: {
        ...e.headers,
        Authorization: t ? `Basic ${btoa(`${t}:${s}`)}` : void 0,
        "User-Agent": yt.userAgent
      }
    };
    this.sdk = be(a), this.sdkCloud = be({
      ...a,
      baseUrl: At
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(e, ...t) {
    const s = await this.sdk.GET(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(e, ...t) {
    const s = await this.sdk.POST(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(e, ...t) {
    const s = await this.sdkCloud.GET(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(e, ...t) {
    const s = await this.sdkCloud.POST(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(e, ...t) {
    const s = await this.sdk.PUT(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(e, ...t) {
    const s = await this.sdk.PATCH(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(e, ...t) {
    const s = await this.sdk.DELETE(e, ...t);
    if (s.error || !s.data)
      throw new d("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
}
class xt extends W {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(e) {
    return this.makeGetRequest("/app-automate/plan.json", e);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(e) {
    return this.makeGetRequest("/app-automate/devices.json", e);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(e) {
    return this.makeGetRequest("/app-automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: e
        }
      },
      body: t
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new d(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(e, t, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param body - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", e.file, e.filename), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...t,
        params: {
          path: {
            mediaId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param body - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(e, t) {
    return this.makePostRequest("/app-automate/upload", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(e) {
    return this.makeGetRequest("/app-automate/recent_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(e) {
    return this.makeGetRequest("/app-automate/recent_group_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(e, t) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param body - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(e, t, s) {
    return this.makePostRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return "file" in t ? a.append("file", t.file, t.filename) : a.append("url", t.url), t.custom_id && a.append("custom_id", t.custom_id), a;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(e, t) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      t
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(e, t, s) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    ).then((a) => "app" in a ? a.app : a.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(e, t, s) {
    return this.makeDeleteRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param body - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(e, t) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(e, t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(e, t) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param body - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(e, t) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(e, t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(e, t) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  uploadDetoxAndroidApp(e, t, s) {
    return this.makePostRequest(
      e ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return "file" in t ? a.append("file", t.file, t.filename) : a.append("url", t.url), t.custom_id && a.append("custom_id", t.custom_id), a;
        }
      }
    );
  }
}
class Pt extends W {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(e) {
    return this.makePutRequest("/automate/recycle_key.json", e);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(e) {
    return this.makeGetRequest("/automate/plan.json", e);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/automate/browsers.json", e);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(e) {
    return this.makeGetRequest("/automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new d(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(e, t) {
    return this.makeDeleteRequest("/automate/builds", {
      ...t,
      params: {
        query: {
          "buildId[]": e
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(e, t, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: e
        },
        query: t
      }
    }).then((a) => a.map((n) => n.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(e, t, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(e, t) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...t,
      params: {
        query: {
          "sessionId[]": e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(e, t) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...t,
        params: {
          path: {
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param body - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", e.file, e.filename), s;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(e) {
    return this.makeGetRequest("/automate/recent_media_files", e);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...t,
      params: {
        path: {
          mediaId: e
        }
      }
    });
  }
}
class je extends W {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  getAccountStatus(e) {
    return this.makeGetRequest("/status", e);
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(e, t) {
    return this.makeGetRequest("/browsers", {
      ...t,
      params: {
        query: {
          ...e,
          flat: typeof (e == null ? void 0 : e.flat) == "boolean" ? e.flat : !0
        }
      }
    });
  }
  createWorker(e, t) {
    return this.makePostRequest("/worker", {
      ...t,
      body: e
    });
  }
  getWorkers(e) {
    return this.makeGetRequest("/workers", e);
  }
  getWorker(e, t) {
    return this.makeGetRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
  deleteWorker(e, t) {
    return this.makeDeleteRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
}
var b = Uint8Array, L = Uint16Array, Dt = Int32Array, xe = new b([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), Pe = new b([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), _t = new b([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), De = function(r, e) {
  for (var t = new L(31), s = 0; s < 31; ++s)
    t[s] = e += 1 << r[s - 1];
  for (var a = new Dt(t[30]), s = 1; s < 30; ++s)
    for (var n = t[s]; n < t[s + 1]; ++n)
      a[n] = n - t[s] << 5 | s;
  return { b: t, r: a };
}, _e = De(xe, 2), Te = _e.b, Tt = _e.r;
Te[28] = 258, Tt[258] = 28;
var Bt = De(Pe, 0), Gt = Bt.b, pe = new L(32768);
for (var h = 0; h < 32768; ++h) {
  var C = (h & 43690) >> 1 | (h & 21845) << 1;
  C = (C & 52428) >> 2 | (C & 13107) << 2, C = (C & 61680) >> 4 | (C & 3855) << 4, pe[h] = ((C & 65280) >> 8 | (C & 255) << 8) >> 1;
}
var K = function(r, e, t) {
  for (var s = r.length, a = 0, n = new L(e); a < s; ++a)
    r[a] && ++n[r[a] - 1];
  var o = new L(e);
  for (a = 1; a < e; ++a)
    o[a] = o[a - 1] + n[a - 1] << 1;
  var u;
  if (t) {
    u = new L(1 << e);
    var p = 15 - e;
    for (a = 0; a < s; ++a)
      if (r[a])
        for (var l = a << 4 | r[a], m = e - r[a], i = o[r[a] - 1]++ << m, c = i | (1 << m) - 1; i <= c; ++i)
          u[pe[i] >> p] = l;
  } else
    for (u = new L(s), a = 0; a < s; ++a)
      r[a] && (u[a] = pe[o[r[a] - 1]++] >> 15 - r[a]);
  return u;
}, N = new b(288);
for (var h = 0; h < 144; ++h)
  N[h] = 8;
for (var h = 144; h < 256; ++h)
  N[h] = 9;
for (var h = 256; h < 280; ++h)
  N[h] = 7;
for (var h = 280; h < 288; ++h)
  N[h] = 8;
var Be = new b(32);
for (var h = 0; h < 32; ++h)
  Be[h] = 5;
var Ct = /* @__PURE__ */ K(N, 9, 1), Et = /* @__PURE__ */ K(Be, 5, 1), ne = function(r) {
  for (var e = r[0], t = 1; t < r.length; ++t)
    r[t] > e && (e = r[t]);
  return e;
}, D = function(r, e, t) {
  var s = e / 8 | 0;
  return (r[s] | r[s + 1] << 8) >> (e & 7) & t;
}, ie = function(r, e) {
  var t = e / 8 | 0;
  return (r[t] | r[t + 1] << 8 | r[t + 2] << 16) >> (e & 7);
}, $t = function(r) {
  return (r + 7) / 8 | 0;
}, le = function(r, e, t) {
  return (e == null || e < 0) && (e = 0), (t == null || t > r.length) && (t = r.length), new b(r.subarray(e, t));
}, Ut = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], I = function(r, e, t) {
  var s = new Error(e || Ut[r]);
  if (s.code = r, Error.captureStackTrace && Error.captureStackTrace(s, I), !t)
    throw s;
  return s;
}, Ot = function(r, e, t, s) {
  var a = r.length, n = s ? s.length : 0;
  if (!a || e.f && !e.l)
    return t || new b(0);
  var o = !t, u = o || e.i != 2, p = e.i;
  o && (t = new b(a * 3));
  var l = function(ke) {
    var ye = t.length;
    if (ke > ye) {
      var Re = new b(Math.max(ye * 2, ke));
      Re.set(t), t = Re;
    }
  }, m = e.f || 0, i = e.p || 0, c = e.b || 0, f = e.l, k = e.d, q = e.m, v = e.n, R = a * 8;
  do {
    if (!f) {
      m = D(r, i, 1);
      var S = D(r, i + 1, 3);
      if (i += 3, S)
        if (S == 1)
          f = Ct, k = Et, q = 9, v = 5;
        else if (S == 2) {
          var y = D(r, i, 31) + 257, $ = D(r, i + 10, 15) + 4, E = y + D(r, i + 5, 31) + 1;
          i += 14;
          for (var M = new b(E), ee = new b(19), j = 0; j < $; ++j)
            ee[_t[j]] = D(r, i + j * 3, 7);
          i += $ * 3;
          for (var de = ne(ee), $e = (1 << de) - 1, Ue = K(ee, de, 1), j = 0; j < E; ) {
            var he = Ue[D(r, i, $e)];
            i += he & 15;
            var g = he >> 4;
            if (g < 16)
              M[j++] = g;
            else {
              var U = 0, V = 0;
              for (g == 16 ? (V = 3 + D(r, i, 3), i += 2, U = M[j - 1]) : g == 17 ? (V = 3 + D(r, i, 7), i += 3) : g == 18 && (V = 11 + D(r, i, 127), i += 7); V--; )
                M[j++] = U;
            }
          }
          var fe = M.subarray(0, y), G = M.subarray(y);
          q = ne(fe), v = ne(G), f = K(fe, q, 1), k = K(G, v, 1);
        } else
          I(1);
      else {
        var g = $t(i) + 4, w = r[g - 4] | r[g - 3] << 8, T = g + w;
        if (T > a) {
          p && I(0);
          break;
        }
        u && l(c + w), t.set(r.subarray(g, T), c), e.b = c += w, e.p = i = T * 8, e.f = m;
        continue;
      }
      if (i > R) {
        p && I(0);
        break;
      }
    }
    u && l(c + 131072);
    for (var Oe = (1 << q) - 1, Le = (1 << v) - 1, te = i; ; te = i) {
      var U = f[ie(r, i) & Oe], O = U >> 4;
      if (i += U & 15, i > R) {
        p && I(0);
        break;
      }
      if (U || I(2), O < 256)
        t[c++] = O;
      else if (O == 256) {
        te = i, f = null;
        break;
      } else {
        var we = O - 254;
        if (O > 264) {
          var j = O - 257, H = xe[j];
          we = D(r, i, (1 << H) - 1) + Te[j], i += H;
        }
        var se = k[ie(r, i) & Le], re = se >> 4;
        se || I(3), i += se & 15;
        var G = Gt[re];
        if (re > 3) {
          var H = Pe[re];
          G += ie(r, i) & (1 << H) - 1, i += H;
        }
        if (i > R) {
          p && I(0);
          break;
        }
        u && l(c + 131072);
        var ge = c + we;
        if (c < G) {
          var ve = n - G, ze = Math.min(G, ge);
          for (ve + c < 0 && I(3); c < ze; ++c)
            t[c] = s[ve + c];
        }
        for (; c < ge; ++c)
          t[c] = t[c - G];
      }
    }
    e.l = f, e.p = te, e.b = c, e.f = m, f && (m = 1, e.m = q, e.d = k, e.n = v);
  } while (!m);
  return c != t.length && o ? le(t, 0, c) : t.subarray(0, c);
}, Lt = /* @__PURE__ */ new b(0), B = function(r, e) {
  return r[e] | r[e + 1] << 8;
}, _ = function(r, e) {
  return (r[e] | r[e + 1] << 8 | r[e + 2] << 16 | r[e + 3] << 24) >>> 0;
}, oe = function(r, e) {
  return _(r, e) + _(r, e + 4) * 4294967296;
};
function zt(r, e) {
  return Ot(r, { i: 2 }, e && e.out, e && e.dictionary);
}
var ce = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), Mt = 0;
try {
  ce.decode(Lt, { stream: !0 }), Mt = 1;
} catch {
}
var Ht = function(r) {
  for (var e = "", t = 0; ; ) {
    var s = r[t++], a = (s > 127) + (s > 223) + (s > 239);
    if (t + a > r.length)
      return { s: e, r: le(r, t - 1) };
    a ? a == 3 ? (s = ((s & 15) << 18 | (r[t++] & 63) << 12 | (r[t++] & 63) << 6 | r[t++] & 63) - 65536, e += String.fromCharCode(55296 | s >> 10, 56320 | s & 1023)) : a & 1 ? e += String.fromCharCode((s & 31) << 6 | r[t++] & 63) : e += String.fromCharCode((s & 15) << 12 | (r[t++] & 63) << 6 | r[t++] & 63) : e += String.fromCharCode(s);
  }
};
function Kt(r, e) {
  if (e) {
    for (var t = "", s = 0; s < r.length; s += 16384)
      t += String.fromCharCode.apply(null, r.subarray(s, s + 16384));
    return t;
  } else {
    if (ce)
      return ce.decode(r);
    var a = Ht(r), n = a.s, t = a.r;
    return t.length && I(8), n;
  }
}
var Ft = function(r, e) {
  return e + 30 + B(r, e + 26) + B(r, e + 28);
}, Wt = function(r, e, t) {
  var s = B(r, e + 28), a = Kt(r.subarray(e + 46, e + 46 + s), !(B(r, e + 8) & 2048)), n = e + 46 + s, o = _(r, e + 20), u = t && o == 4294967295 ? Nt(r, n) : [o, _(r, e + 24), _(r, e + 42)], p = u[0], l = u[1], m = u[2];
  return [B(r, e + 10), p, l, a, n + B(r, e + 30) + B(r, e + 32), m];
}, Nt = function(r, e) {
  for (; B(r, e) != 1; e += 4 + B(r, e + 2))
    ;
  return [oe(r, e + 12), oe(r, e + 4), oe(r, e + 20)];
};
function Vt(r, e) {
  for (var t = {}, s = r.length - 22; _(r, s) != 101010256; --s)
    (!s || r.length - s > 65558) && I(13);
  var a = B(r, s + 8);
  if (!a)
    return {};
  var n = _(r, s + 16), o = n == 4294967295 || a == 65535;
  if (o) {
    var u = _(r, s - 12);
    o = _(r, u) == 101075792, o && (a = _(r, u + 32), n = _(r, u + 48));
  }
  for (var p = e && e.filter, l = 0; l < a; ++l) {
    var m = Wt(r, n, o), i = m[0], c = m[1], f = m[2], k = m[3], q = m[4], v = m[5], R = Ft(r, v);
    n = q, (!p || p({
      name: k,
      size: c,
      originalSize: f,
      compression: i
    })) && (i ? i == 8 ? t[k] = zt(r.subarray(R, R + c), { out: new b(f) }) : I(14, "unknown compression type " + i) : t[k] = le(r, R, R + c));
  }
  return t;
}
class Ge extends W {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    P(this, "authToken");
    const s = (t == null ? void 0 : t.key) ?? F.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new d("Missing options.key");
    this.authToken = s;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(t, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...t,
          auth_token: this.authToken
        }
      }
    }).then((a) => a.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(t, s, a) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...a,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => {
      if (!n.instances.length)
        throw new d(
          `No Local binary instance found with id "${t}"`
        );
      return n.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(t, s, a) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...a,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => n.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(t, s = "BrowserStackLocal", a) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...a,
      params: {
        path: {
          osArch: t
        }
      },
      parseAs: "arrayBuffer"
    }).then((n) => n.response.arrayBuffer()).then((n) => {
      const o = Vt(new Uint8Array(n), {
        filter: (l) => l.name.startsWith(s)
      }), u = Object.keys(o);
      if (!u.length)
        throw new d(
          `Local binary not found in BrowserStackLocal-${t}.zip`
        );
      return { content: o[u[0]], filename: u[0] };
    }).catch((n) => {
      throw n instanceof d ? n : new d(
        `Failed to write local binary to disk: ${n.message}: ${n.stack}`
      );
    });
  }
}
class Jt extends W {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/screenshots/browsers.json", e);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(e, t) {
    return this.makePostRequest("/screenshots", {
      ...t,
      body: e
    });
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(e, t) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...t,
      params: {
        path: {
          jobId: e
        }
      }
    });
  }
}
const Xt = {
  AutomateClient: Pt,
  ScreenshotsClient: Jt,
  AppAutomateClient: xt,
  JSTestingClient: je,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: je,
  LocalTestingClient: Ge
};
async function Qt(r, e = "BrowserStackLocal") {
  const t = await Ce(r), a = await Ee() === "win32" ? `${e}.exe` : e, n = Ie(t, a);
  if (!await Y(n, z.R_OK | z.X_OK))
    throw new d(`Missing or inaccessible file: ${n}`);
  return n;
}
async function Y(r, e) {
  if (typeof r != "string" || !r.trim().length)
    return !1;
  e = e ?? z.R_OK;
  const t = await Z(r);
  return !(!t.isFile() || (t.mode & e) !== e);
}
async function Yt(r, e) {
  if (typeof r != "string" || !r.trim().length)
    return !1;
  e = e ?? z.R_OK;
  const t = await Z(r);
  return !(!t.isDirectory() || (t.mode & e) !== e);
}
async function Ce(r, e = 493, t) {
  try {
    t = t ?? z.R_OK | z.W_OK;
    const s = Ae(r), a = await Z(s).catch(() => null);
    return (!a || !a.isDirectory()) && await Fe(s, { recursive: !0, mode: e }), a && (a.mode & t) !== t && await We(s, e), s;
  } catch (s) {
    throw s instanceof Error ? new d(
      `Missing or inaccessible directory: ${r}`,
      s
    ) : s;
  }
}
async function Ee() {
  if (["x64", "ia32"].includes(J))
    switch (qe) {
      case "darwin":
        if (J === "x64")
          return "darwin-x64";
        break;
      case "win32":
      case "cygwin":
        return "win32";
      case "linux":
        if (J === "ia32")
          return "linux-ia32";
        try {
          if (Ke("ldd", ["--version"]).stderr.toString("utf8").indexOf("musl") !== -1)
            return "alpine";
        } catch {
        }
        return "linux-x64";
    }
  throw new d(
    `Unsupported platform/arch: ${qe}/${J}`
  );
}
async function Zt(r, e, t, s) {
  const a = Ie(Ae(r), e);
  try {
    return await Ne(a, t, { mode: s }), a;
  } catch (n) {
    try {
      (await Z(a)).isFile() && await Ve(a);
    } catch {
    }
    throw n;
  }
}
class me extends Ge {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    var a, n;
    super(t);
    P(this, "localIdentifier");
    P(this, "child", {
      pid: void 0,
      args: []
    });
    P(this, "commandTimeoutMs");
    /**
     * The last state of the BrowserStackLocal daemon command.
     * @public
     */
    P(this, "state", "stopped");
    this.options = t;
    const s = (t == null ? void 0 : t.localIdentifier) ?? ((n = (a = F.BROWSERSTACK_LOCAL_ID) == null ? void 0 : a.trim) == null ? void 0 : n.call(a)) ?? Je(16).toString("hex");
    if (typeof s != "string" || !s.trim().length)
      throw new d("Missing options.localIdentifier.id");
    this.localIdentifier = s, this.commandTimeoutMs = (t == null ? void 0 : t.commandTimeoutMs) ?? 1e4;
  }
  /**
   * Retrieves the version of the local testing binary.
   * @returns A promise that resolves to the version string.
   */
  async version() {
    const t = await this.ensureBinaryExists(), s = this.getBinHome();
    return new Promise((a, n) => {
      var m, i, c, f, k, q, v, R, S, g;
      const o = Se.spawnSync(t, ["--version"], {
        timeout: this.commandTimeoutMs,
        cwd: s,
        windowsHide: !0
      }), u = (f = (c = (i = (m = o.stdout) == null ? void 0 : m.toString) == null ? void 0 : i.call(m, "utf8")) == null ? void 0 : c.trim) == null ? void 0 : f.call(c), p = (q = (k = u == null ? void 0 : u.match(/\s+version\s+(.*)$/i)) == null ? void 0 : k[1]) == null ? void 0 : q.trim();
      if (typeof p == "string")
        return a(p);
      const l = (g = (S = (R = (v = o.stderr) == null ? void 0 : v.toString) == null ? void 0 : R.call(v, "utf8")) == null ? void 0 : S.trim) == null ? void 0 : g.call(S);
      n(
        new d(
          `Failed to get version: ${l ?? u} (status=${o.status})`
        )
      );
    });
  }
  /**
   * Starts the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the binary starts successfully, or undefined if there is an error.
   */
  async start() {
    let t;
    return await this.runDaemonCommand({
      action: "start",
      initialState: "starting",
      successState: "started",
      isSuccess: (s, a, n) => {
        const o = a === "connected";
        return t ?? (t = n), o;
      }
    }).catch((s) => {
      throw t && Object.assign(s, { message: t }), s;
    }), t;
  }
  /**
   * Stops the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the daemon stops successfully, or undefined otherwise.
   */
  async stop() {
    let t;
    return await this.runDaemonCommand({
      action: "stop",
      initialState: "stopping",
      successState: "stopped",
      isSuccess: (s, a, n) => {
        var u, p, l;
        return t ?? (t = n), a === "success" && ((l = (p = (u = n == null ? void 0 : n.toLowerCase) == null ? void 0 : u.call(n)) == null ? void 0 : p.includes) == null ? void 0 : l.call(p, "stopped successfully")) === !0;
      }
    }).catch((s) => {
      throw t && Object.assign(s, { message: t }), s;
    }), t;
  }
  /**
   * @internal
   */
  async runDaemonCommand(t, s = this.commandTimeoutMs) {
    const a = {
      state: this.state,
      pid: this.child.pid,
      args: this.child.args
    }, n = (l) => {
      throw this.state = a.state, this.child.pid = a.pid, this.child.args = a.args, l;
    }, o = await this.ensureBinaryExists().catch(n), u = this.getBinHome(), p = await me.resolveArgs(
      this.authToken,
      this.localIdentifier,
      t.action,
      this.options
    );
    return new Promise((l, m) => {
      var k, q, v, R, S, g, w, T;
      this.state = t.initialState;
      const i = Se.spawnSync(o, p, {
        timeout: s,
        cwd: u,
        windowsHide: !0
      });
      if (i.error)
        return m(new d(i.error.message, i.error));
      const c = (R = (v = (q = (k = i.stdout) == null ? void 0 : k.toString) == null ? void 0 : q.call(k, "utf8")) == null ? void 0 : v.trim) == null ? void 0 : R.call(v);
      if (c)
        try {
          const y = JSON.parse(c);
          if (y && typeof y == "object") {
            const { state: $, message: E } = this.parseOutput(y);
            if (t.isSuccess(y, $, E))
              return this.state = t.successState, t.action === "start" ? (this.child.pid = y.pid ?? i.pid, this.child.args = p.slice(2)) : t.action === "stop" && (this.child.pid = void 0, this.child.args = []), l();
          }
        } catch {
        }
      const f = (T = (w = (g = (S = i.stderr) == null ? void 0 : S.toString) == null ? void 0 : g.call(S, "utf8")) == null ? void 0 : w.trim) == null ? void 0 : T.call(w);
      if (f)
        try {
          const y = JSON.parse(f);
          if (y && typeof y == "object") {
            const { state: $, message: E } = this.parseOutput(y);
            if (E)
              return m(new d(`${E} state=${$}`));
          }
        } catch {
        }
      return m(new d(f ?? c));
    }).catch(n);
  }
  /**
   * @internal
   */
  static async resolveArgs(t, s, a, n) {
    if (typeof t != "string" || !t.trim().length)
      throw new d("Required: key");
    if (typeof s != "string" || !s.trim().length)
      throw new d("Required: localIdentifier");
    const o = [
      "--key",
      t.trim(),
      "--local-identifier",
      s.trim(),
      "--daemon",
      a
    ];
    if (!n)
      return o;
    const u = async ({ rootCA: l }) => {
      l && "useSystem" in l && l.useSystem === !0 && o.push("--use-system-installed-ca"), l && "path" in l && l.path && await Y(l.path) && o.push("--use-ca-certificate", l.path);
    };
    if ((n == null ? void 0 : n.disableAPILogging) !== !0 && o.push("--enable-logging-for-api"), n.forceLocal === !0)
      o.push("--force-local");
    else if (n.only) {
      const l = n.only.map(
        ({ host: m, port: i, ssl: c }) => `${m},${i},${c ? 1 : 0}`
      );
      o.push("--only", l.join(","));
    }
    if ("folder" in n && await Yt(n.folder))
      o.push("--folder", n.folder);
    else if ("localProxy" in n && n.localProxy) {
      const {
        host: l,
        port: m,
        auth: { username: i, password: c } = {
          username: void 0,
          password: void 0
        }
      } = n.localProxy;
      o.push("--local-proxy-host", l.trim()), m && o.push("--local-proxy-port", `${m}`), i && c && (o.push("--local-proxy-user", i.trim()), o.push("--local-proxy-pass", c.trim())), await u(n.localProxy);
    }
    const p = n == null ? void 0 : n.proxy;
    if (p)
      if (typeof p == "string")
        if (await Y(p))
          o.push("--proxy-pac", p);
        else
          throw new d(`Invalid proxy pac file: ${p}`);
      else {
        const {
          host: l,
          port: m,
          auth: { username: i, password: c } = {
            username: void 0,
            password: void 0
          },
          force: f
        } = p;
        o.push("--proxy-host", l.trim()), m && o.push("--proxy-port", `${m}`), i && c && (o.push("--proxy-user", i.trim()), o.push("--proxy-pass", c.trim())), f && o.push("--force-proxy"), await u(p);
      }
    if (n.onlyAutomate === !0 && o.push("--only-automate"), n.debug) {
      const { level: l, logFile: m } = n.debug;
      l && o.push("--verbose", `${l}`), m && o.push("--log-file", m);
    }
    if (n.timeout && o.push("--timeout", `${n.timeout}`), n.parallelRuns && o.push("--parallel-runs", `${n.parallelRuns}`), n.hosts) {
      const { include: l, exclude: m } = n.hosts;
      Array.isArray(l) && l.length && o.push("--include-hosts", ...l), Array.isArray(m) && m.length && o.push("--exclude-hosts", ...m);
    }
    return o.concat(n.more ?? []);
  }
  get pid() {
    var t;
    return (t = this.child) == null ? void 0 : t.pid;
  }
  get args() {
    var t, s;
    return (t = this.child) != null && t.args ? Array.from((s = this.child) == null ? void 0 : s.args) : [];
  }
  /**
   * @internal
   */
  parseOutput(t) {
    let s, a, n;
    return typeof t.status == "string" && (s = t.status.trim()), typeof t.state == "string" && (s = t.state.trim()), typeof t.pid == "string" && (a = t.pid.trim()), "message" in t && t.message && (typeof t.message == "string" ? n = t.message.trim() : typeof t.message == "object" && (n = "message" in t.message && typeof t.message.message == "string" ? t.message.message.trim() : void 0)), { state: s, pid: a, message: n };
  }
  /**
   * @internal
   */
  getBinHome() {
    var s;
    const t = ((s = this.options) == null ? void 0 : s.binHome) ?? F.BROWSERSTACK_LOCAL_BINARY_PATH;
    if (typeof t != "string" || !t.trim().length)
      throw new d("Missing options.binHome");
    return t.trim();
  }
  /**
   * @internal
   */
  async ensureBinaryExists() {
    try {
      const s = await Qt(this.getBinHome());
      if (await Y(s))
        return s;
    } catch {
    }
    const t = await Ee();
    if (!t)
      throw new d(`Unsupported platform: ${t}`);
    try {
      const s = await Ce(this.getBinHome()), { content: a, filename: n } = await this.downloadBinary(t);
      return await Zt(s, n, a, 493);
    } catch (s) {
      throw s instanceof d ? s : s instanceof Error ? new d(
        `Failed to download binary: ${s.message}`,
        s
      ) : new d(`Failed to download binary: ${s}`);
    }
  }
}
const ns = {
  ...Xt,
  LocalTestingBinary: me
};
export {
  ns as BrowserStack
};
