var De = Object.defineProperty;
var Ce = (a, e, t) => e in a ? De(a, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : a[e] = t;
var x = (a, e, t) => (Ce(a, typeof e != "symbol" ? e + "" : e, t), t);
const b = globalThis.process ?? { env: {}, versions: {} }, te = { ...b == null ? void 0 : b.env }, Te = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...b == null ? void 0 : b.versions
};
b == null || b.platform;
b == null || b.arch;
class f extends Error {
  constructor(t, s) {
    super(t);
    x(this, "code");
    x(this, "stack");
    x(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack);
  }
}
const _e = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], xe = "browserstack-client", Be = "3.0.0-next.10", Fe = "BrowserStack APIs client library for node.js", Ee = "module", Ue = "./dist/browserstack-client.umd.cjs", ze = "./dist/browserstack-client.js", Le = "./dist/types/index.d.ts", $e = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/node/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.umd.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, Oe = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs"
}, Me = "Shirish Kamath", He = "MIT", Ke = [
  "dist/**/*",
  "*.d.ts"
], We = {
  node: ">=18.0.0"
}, Ne = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.6",
  "@typescript-eslint/eslint-plugin": "^6.19.1",
  "@typescript-eslint/parser": "^6.19.1",
  "@vitest/coverage-v8": "^1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.5",
  typedoc: "^0.25.7",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.0",
  typescript: "^5.2.2",
  vite: "^5.0.8",
  "vite-plugin-dts": "^3.7.2",
  vitepress: "^1.0.0-rc.40",
  vitest: "1.2.1"
}, Ve = {
  fflate: "^0.8.1",
  "openapi-fetch": "^0.8.2"
}, Je = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, Xe = "https://shirish87.github.io/browserstack-client/", Qe = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, Ye = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], q = {
  name: xe,
  version: Be,
  description: Fe,
  type: Ee,
  main: Ue,
  module: ze,
  types: Le,
  exports: $e,
  scripts: Oe,
  author: Me,
  license: He,
  files: Ke,
  engines: We,
  devDependencies: Ne,
  dependencies: Ve,
  repository: Je,
  homepage: Xe,
  bugs: Qe,
  keywords: Ye
}, Ze = [q == null ? void 0 : q.name, q == null ? void 0 : q.version].filter(Boolean).join("/"), et = ["node", Te.node].filter(Boolean).join("/"), tt = [Ze, et].filter(Boolean).join(" "), st = {
  name: q == null ? void 0 : q.name,
  version: q == null ? void 0 : q.version,
  userAgent: tt
}, at = {
  "Content-Type": "application/json"
};
function ge(a) {
  const {
    fetch: e = globalThis.fetch,
    querySerializer: t,
    bodySerializer: s,
    ...r
  } = a ?? {};
  let n = r.baseUrl ?? "";
  n.endsWith("/") && (n = n.slice(0, -1));
  async function l(o, u) {
    const {
      fetch: h = e,
      headers: c,
      body: i,
      params: p = {},
      parseAs: k = "json",
      querySerializer: I = t ?? rt,
      bodySerializer: G = s ?? nt,
      ...P
    } = u || {}, y = it(o, {
      baseUrl: n,
      params: p,
      querySerializer: I
    }), B = ot(
      at,
      a == null ? void 0 : a.headers,
      c,
      p.header
    ), g = {
      redirect: "follow",
      ...r,
      ...P,
      headers: B
    };
    i && (g.body = G(i)), g.body instanceof FormData && B.delete("Content-Type");
    const d = await h(y, g);
    if (d.status === 204 || d.headers.get("Content-Length") === "0")
      return d.ok ? { data: {}, response: d } : { error: {}, response: d };
    if (d.ok) {
      if (k === "stream")
        return { data: d.clone().body, response: d };
      const _ = d.clone();
      return {
        data: typeof _[k] == "function" ? await _[k]() : await _.text(),
        response: d
      };
    }
    let T = {};
    try {
      T = await d.clone().json();
    } catch {
      T = await d.clone().text();
    }
    return { error: T, response: d };
  }
  return {
    /** Call a GET endpoint */
    async GET(o, u) {
      return l(o, { ...u, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(o, u) {
      return l(o, { ...u, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(o, u) {
      return l(o, { ...u, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(o, u) {
      return l(o, { ...u, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(o, u) {
      return l(o, { ...u, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(o, u) {
      return l(o, { ...u, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(o, u) {
      return l(o, { ...u, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(o, u) {
      return l(o, { ...u, method: "TRACE" });
    }
  };
}
function rt(a) {
  const e = [];
  if (a && typeof a == "object")
    for (const [t, s] of Object.entries(a)) {
      const r = se([t], s);
      r && e.push(r);
    }
  return e.join("&");
}
function se(a, e) {
  if (e != null) {
    if (typeof e == "string")
      return `${Q(a)}=${encodeURIComponent(e)}`;
    if (typeof e == "number" || typeof e == "boolean")
      return `${Q(a)}=${String(e)}`;
    if (Array.isArray(e)) {
      if (!e.length)
        return;
      const t = [];
      for (const s of e) {
        const r = se(a, s);
        r !== void 0 && t.push(r);
      }
      return t.join("&");
    }
    if (typeof e == "object") {
      if (!Object.keys(e).length)
        return;
      const t = [];
      for (const [s, r] of Object.entries(e))
        if (r != null) {
          const n = se([...a, s], r);
          n !== void 0 && t.push(n);
        }
      return t.join("&");
    }
    return encodeURIComponent(`${Q(a)}=${String(e)}`);
  }
}
function Q(a) {
  let e = a[0];
  for (const t of a.slice(1))
    e += `[${t}]`;
  return e;
}
function nt(a) {
  return JSON.stringify(a);
}
function it(a, e) {
  let t = `${e.baseUrl}${a}`;
  if (e.params.path)
    for (const [r, n] of Object.entries(e.params.path))
      t = t.replace(`{${r}}`, encodeURIComponent(String(n)));
  const s = e.querySerializer(e.params.query ?? {});
  return s && (t += `?${s}`), t;
}
function ot(...a) {
  const e = new Headers();
  for (const t of a) {
    if (!t || typeof t != "object")
      continue;
    const s = t instanceof Headers ? t.entries() : Object.entries(t);
    for (const [r, n] of s)
      n === null ? e.delete(r) : n !== void 0 && e.set(r, n);
  }
  return e;
}
const [{ variables: K }, { variables: W }] = _e ?? [], ut = `${K.scheme.default}://${K.host.default}${K.basePath ? K.basePath.default : ""}`, pt = `${W.scheme.default}://${W.host.default}${W.basePath ? W.basePath.default : ""}`;
class O {
  constructor(e) {
    x(this, "sdk");
    x(this, "sdkCloud");
    const t = e.username ?? te.BROWSERSTACK_USERNAME;
    if (e.usernameOptional !== !0 && (typeof t != "string" || !t.trim().length))
      throw new f("Missing options.username");
    const s = e.key ?? te.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new f("Missing options.key");
    const r = {
      ...e,
      baseUrl: e.baseUrl ?? ut,
      headers: {
        ...e.headers,
        Authorization: t ? `Basic ${btoa(`${t}:${s}`)}` : void 0,
        "User-Agent": st.userAgent
      }
    };
    this.sdk = ge(r), this.sdkCloud = ge({
      ...r,
      baseUrl: pt
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(e, ...t) {
    const s = await this.sdk.GET(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(e, ...t) {
    const s = await this.sdk.POST(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(e, ...t) {
    const s = await this.sdkCloud.GET(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(e, ...t) {
    const s = await this.sdkCloud.POST(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(e, ...t) {
    const s = await this.sdk.PUT(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(e, ...t) {
    const s = await this.sdk.PATCH(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(e, ...t) {
    const s = await this.sdk.DELETE(e, ...t);
    if (s.error || !s.data)
      throw new f("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
}
class lt extends O {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(e) {
    return this.makeGetRequest("/app-automate/plan.json", e);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(e) {
    return this.makeGetRequest("/app-automate/devices.json", e);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(e) {
    return this.makeGetRequest("/app-automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: e
        }
      },
      body: t
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new f(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const r = new FormData();
          return r.append("file", t.file, t.filename), r;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const r = new FormData();
          return r.append("file", t.file, t.filename), r;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(e, t, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param body - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", e.file, e.filename), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...t,
        params: {
          path: {
            mediaId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param body - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(e, t) {
    return this.makePostRequest("/app-automate/upload", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(e) {
    return this.makeGetRequest("/app-automate/recent_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(e) {
    return this.makeGetRequest("/app-automate/recent_group_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(e, t) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param body - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(e, t, s) {
    return this.makePostRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const r = new FormData();
          return "file" in t ? r.append("file", t.file, t.filename) : r.append("url", t.url), t.custom_id && r.append("custom_id", t.custom_id), r;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(e, t) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      t
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(e, t, s) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    ).then((r) => "app" in r ? r.app : r.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(e, t, s) {
    return this.makeDeleteRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param body - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(e, t) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(e, t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(e, t) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param body - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(e, t) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(e, t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(e, t) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  uploadDetoxAndroidApp(e, t, s) {
    return this.makePostRequest(
      e ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const r = new FormData();
          return "file" in t ? r.append("file", t.file, t.filename) : r.append("url", t.url), t.custom_id && r.append("custom_id", t.custom_id), r;
        }
      }
    );
  }
}
class mt extends O {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(e) {
    return this.makePutRequest("/automate/recycle_key.json", e);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(e) {
    return this.makeGetRequest("/automate/plan.json", e);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/automate/browsers.json", e);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(e) {
    return this.makeGetRequest("/automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new f(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(e, t) {
    return this.makeDeleteRequest("/automate/builds", {
      ...t,
      params: {
        query: {
          "buildId[]": e
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(e, t, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: e
        },
        query: t
      }
    }).then((r) => r.map((n) => n.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(e, t, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(e, t) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...t,
      params: {
        query: {
          "sessionId[]": e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const r = new FormData();
          return r.append("file", t.file, t.filename), r;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const r = new FormData();
          return r.append("file", t.file, t.filename), r;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(e, t) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...t,
        params: {
          path: {
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param body - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", e.file, e.filename), s;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(e) {
    return this.makeGetRequest("/automate/recent_media_files", e);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...t,
      params: {
        path: {
          mediaId: e
        }
      }
    });
  }
}
class ve extends O {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  getAccountStatus(e) {
    return this.makeGetRequest("/status", e);
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(e, t) {
    return this.makeGetRequest("/browsers", {
      ...t,
      params: {
        query: {
          ...e,
          flat: typeof (e == null ? void 0 : e.flat) == "boolean" ? e.flat : !0
        }
      }
    });
  }
  createWorker(e, t) {
    return this.makePostRequest("/worker", {
      ...t,
      body: e
    });
  }
  getWorkers(e) {
    return this.makeGetRequest("/workers", e);
  }
  getWorker(e, t) {
    return this.makeGetRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
  deleteWorker(e, t) {
    return this.makeDeleteRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
}
var v = Uint8Array, U = Uint16Array, ct = Int32Array, we = new v([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), Re = new v([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), dt = new v([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), qe = function(a, e) {
  for (var t = new U(31), s = 0; s < 31; ++s)
    t[s] = e += 1 << a[s - 1];
  for (var r = new ct(t[30]), s = 1; s < 30; ++s)
    for (var n = t[s]; n < t[s + 1]; ++n)
      r[n] = n - t[s] << 5 | s;
  return { b: t, r };
}, be = qe(we, 2), je = be.b, ft = be.r;
je[28] = 258, ft[258] = 28;
var ht = qe(Re, 0), kt = ht.b, ae = new U(32768);
for (var m = 0; m < 32768; ++m) {
  var C = (m & 43690) >> 1 | (m & 21845) << 1;
  C = (C & 52428) >> 2 | (C & 13107) << 2, C = (C & 61680) >> 4 | (C & 3855) << 4, ae[m] = ((C & 65280) >> 8 | (C & 255) << 8) >> 1;
}
var $ = function(a, e, t) {
  for (var s = a.length, r = 0, n = new U(e); r < s; ++r)
    a[r] && ++n[a[r] - 1];
  var l = new U(e);
  for (r = 1; r < e; ++r)
    l[r] = l[r - 1] + n[r - 1] << 1;
  var o;
  if (t) {
    o = new U(1 << e);
    var u = 15 - e;
    for (r = 0; r < s; ++r)
      if (a[r])
        for (var h = r << 4 | a[r], c = e - a[r], i = l[a[r] - 1]++ << c, p = i | (1 << c) - 1; i <= p; ++i)
          o[ae[i] >> u] = h;
  } else
    for (o = new U(s), r = 0; r < s; ++r)
      a[r] && (o[r] = ae[l[a[r] - 1]++] >> 15 - a[r]);
  return o;
}, M = new v(288);
for (var m = 0; m < 144; ++m)
  M[m] = 8;
for (var m = 144; m < 256; ++m)
  M[m] = 9;
for (var m = 256; m < 280; ++m)
  M[m] = 7;
for (var m = 280; m < 288; ++m)
  M[m] = 8;
var Se = new v(32);
for (var m = 0; m < 32; ++m)
  Se[m] = 5;
var gt = /* @__PURE__ */ $(M, 9, 1), vt = /* @__PURE__ */ $(Se, 5, 1), Y = function(a) {
  for (var e = a[0], t = 1; t < a.length; ++t)
    a[t] > e && (e = a[t]);
  return e;
}, j = function(a, e, t) {
  var s = e / 8 | 0;
  return (a[s] | a[s + 1] << 8) >> (e & 7) & t;
}, Z = function(a, e) {
  var t = e / 8 | 0;
  return (a[t] | a[t + 1] << 8 | a[t + 2] << 16) >> (e & 7);
}, wt = function(a) {
  return (a + 7) / 8 | 0;
}, ne = function(a, e, t) {
  return (e == null || e < 0) && (e = 0), (t == null || t > a.length) && (t = a.length), new v(a.subarray(e, t));
}, Rt = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], R = function(a, e, t) {
  var s = new Error(e || Rt[a]);
  if (s.code = a, Error.captureStackTrace && Error.captureStackTrace(s, R), !t)
    throw s;
  return s;
}, qt = function(a, e, t, s) {
  var r = a.length, n = s ? s.length : 0;
  if (!r || e.f && !e.l)
    return t || new v(0);
  var l = !t, o = l || e.i != 2, u = e.i;
  l && (t = new v(r * 3));
  var h = function(fe) {
    var he = t.length;
    if (fe > he) {
      var ke = new v(Math.max(he * 2, fe));
      ke.set(t), t = ke;
    }
  }, c = e.f || 0, i = e.p || 0, p = e.b || 0, k = e.l, I = e.d, G = e.m, P = e.n, y = r * 8;
  do {
    if (!k) {
      c = j(a, i, 1);
      var B = j(a, i + 1, 3);
      if (i += 3, B)
        if (B == 1)
          k = gt, I = vt, G = 9, P = 5;
        else if (B == 2) {
          var _ = j(a, i, 31) + 257, ie = j(a, i + 10, 15) + 4, oe = _ + j(a, i + 5, 31) + 1;
          i += 14;
          for (var z = new v(oe), N = new v(19), w = 0; w < ie; ++w)
            N[dt[w]] = j(a, i + w * 3, 7);
          i += ie * 3;
          for (var ue = Y(N), Ie = (1 << ue) - 1, ye = $(N, ue, 1), w = 0; w < oe; ) {
            var pe = ye[j(a, i, Ie)];
            i += pe & 15;
            var g = pe >> 4;
            if (g < 16)
              z[w++] = g;
            else {
              var F = 0, H = 0;
              for (g == 16 ? (H = 3 + j(a, i, 3), i += 2, F = z[w - 1]) : g == 17 ? (H = 3 + j(a, i, 7), i += 3) : g == 18 && (H = 11 + j(a, i, 127), i += 7); H--; )
                z[w++] = F;
            }
          }
          var le = z.subarray(0, _), D = z.subarray(_);
          G = Y(le), P = Y(D), k = $(le, G, 1), I = $(D, P, 1);
        } else
          R(1);
      else {
        var g = wt(i) + 4, d = a[g - 4] | a[g - 3] << 8, T = g + d;
        if (T > r) {
          u && R(0);
          break;
        }
        o && h(p + d), t.set(a.subarray(g, T), p), e.b = p += d, e.p = i = T * 8, e.f = c;
        continue;
      }
      if (i > y) {
        u && R(0);
        break;
      }
    }
    o && h(p + 131072);
    for (var Ae = (1 << G) - 1, Ge = (1 << P) - 1, V = i; ; V = i) {
      var F = k[Z(a, i) & Ae], E = F >> 4;
      if (i += F & 15, i > y) {
        u && R(0);
        break;
      }
      if (F || R(2), E < 256)
        t[p++] = E;
      else if (E == 256) {
        V = i, k = null;
        break;
      } else {
        var me = E - 254;
        if (E > 264) {
          var w = E - 257, L = we[w];
          me = j(a, i, (1 << L) - 1) + je[w], i += L;
        }
        var J = I[Z(a, i) & Ge], X = J >> 4;
        J || R(3), i += J & 15;
        var D = kt[X];
        if (X > 3) {
          var L = Re[X];
          D += Z(a, i) & (1 << L) - 1, i += L;
        }
        if (i > y) {
          u && R(0);
          break;
        }
        o && h(p + 131072);
        var ce = p + me;
        if (p < D) {
          var de = n - D, Pe = Math.min(D, ce);
          for (de + p < 0 && R(3); p < Pe; ++p)
            t[p] = s[de + p];
        }
        for (; p < ce; ++p)
          t[p] = t[p - D];
      }
    }
    e.l = k, e.p = V, e.b = p, e.f = c, k && (c = 1, e.m = G, e.d = I, e.n = P);
  } while (!c);
  return p != t.length && l ? ne(t, 0, p) : t.subarray(0, p);
}, bt = /* @__PURE__ */ new v(0), A = function(a, e) {
  return a[e] | a[e + 1] << 8;
}, S = function(a, e) {
  return (a[e] | a[e + 1] << 8 | a[e + 2] << 16 | a[e + 3] << 24) >>> 0;
}, ee = function(a, e) {
  return S(a, e) + S(a, e + 4) * 4294967296;
};
function jt(a, e) {
  return qt(a, { i: 2 }, e && e.out, e && e.dictionary);
}
var re = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), St = 0;
try {
  re.decode(bt, { stream: !0 }), St = 1;
} catch {
}
var It = function(a) {
  for (var e = "", t = 0; ; ) {
    var s = a[t++], r = (s > 127) + (s > 223) + (s > 239);
    if (t + r > a.length)
      return { s: e, r: ne(a, t - 1) };
    r ? r == 3 ? (s = ((s & 15) << 18 | (a[t++] & 63) << 12 | (a[t++] & 63) << 6 | a[t++] & 63) - 65536, e += String.fromCharCode(55296 | s >> 10, 56320 | s & 1023)) : r & 1 ? e += String.fromCharCode((s & 31) << 6 | a[t++] & 63) : e += String.fromCharCode((s & 15) << 12 | (a[t++] & 63) << 6 | a[t++] & 63) : e += String.fromCharCode(s);
  }
};
function yt(a, e) {
  if (e) {
    for (var t = "", s = 0; s < a.length; s += 16384)
      t += String.fromCharCode.apply(null, a.subarray(s, s + 16384));
    return t;
  } else {
    if (re)
      return re.decode(a);
    var r = It(a), n = r.s, t = r.r;
    return t.length && R(8), n;
  }
}
var At = function(a, e) {
  return e + 30 + A(a, e + 26) + A(a, e + 28);
}, Gt = function(a, e, t) {
  var s = A(a, e + 28), r = yt(a.subarray(e + 46, e + 46 + s), !(A(a, e + 8) & 2048)), n = e + 46 + s, l = S(a, e + 20), o = t && l == 4294967295 ? Pt(a, n) : [l, S(a, e + 24), S(a, e + 42)], u = o[0], h = o[1], c = o[2];
  return [A(a, e + 10), u, h, r, n + A(a, e + 30) + A(a, e + 32), c];
}, Pt = function(a, e) {
  for (; A(a, e) != 1; e += 4 + A(a, e + 2))
    ;
  return [ee(a, e + 12), ee(a, e + 4), ee(a, e + 20)];
};
function Dt(a, e) {
  for (var t = {}, s = a.length - 22; S(a, s) != 101010256; --s)
    (!s || a.length - s > 65558) && R(13);
  var r = A(a, s + 8);
  if (!r)
    return {};
  var n = S(a, s + 16), l = n == 4294967295 || r == 65535;
  if (l) {
    var o = S(a, s - 12);
    l = S(a, o) == 101075792, l && (r = S(a, o + 32), n = S(a, o + 48));
  }
  for (var u = e && e.filter, h = 0; h < r; ++h) {
    var c = Gt(a, n, l), i = c[0], p = c[1], k = c[2], I = c[3], G = c[4], P = c[5], y = At(a, P);
    n = G, (!u || u({
      name: I,
      size: p,
      originalSize: k,
      compression: i
    })) && (i ? i == 8 ? t[I] = jt(a.subarray(y, y + p), { out: new v(k) }) : R(14, "unknown compression type " + i) : t[I] = ne(a, y, y + p));
  }
  return t;
}
class Ct extends O {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    x(this, "authToken");
    const s = (t == null ? void 0 : t.key) ?? te.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new f("Missing options.key");
    this.authToken = s;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(t, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...t,
          auth_token: this.authToken
        }
      }
    }).then((r) => r.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(t, s, r) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => {
      if (!n.instances.length)
        throw new f(
          `No Local binary instance found with id "${t}"`
        );
      return n.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(t, s, r) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => n.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(t, s = "BrowserStackLocal", r) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...r,
      params: {
        path: {
          osArch: t
        }
      },
      parseAs: "arrayBuffer"
    }).then((n) => n.response.arrayBuffer()).then((n) => {
      const l = Dt(new Uint8Array(n), {
        filter: (h) => h.name.startsWith(s)
      }), o = Object.keys(l);
      if (!o.length)
        throw new f(
          `Local binary not found in BrowserStackLocal-${t}.zip`
        );
      return { content: l[o[0]], filename: o[0] };
    }).catch((n) => {
      throw n instanceof f ? n : new f(
        `Failed to write local binary to disk: ${n.message}: ${n.stack}`
      );
    });
  }
}
class Tt extends O {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/screenshots/browsers.json", e);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(e, t) {
    return this.makePostRequest("/screenshots", {
      ...t,
      body: e
    });
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(e, t) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...t,
      params: {
        path: {
          jobId: e
        }
      }
    });
  }
}
const xt = {
  AutomateClient: mt,
  ScreenshotsClient: Tt,
  AppAutomateClient: lt,
  JSTestingClient: ve,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: ve,
  LocalTestingClient: Ct
};
export {
  xt as BrowserStack
};
