import { operations } from './generated/openapi.ts';
export declare function binaryPath(binHome: string, filename?: string): Promise<string>;
export declare function fileExists(filePath: string, fileFlags?: number): Promise<boolean>;
export declare function dirExists(dirPath: string, dirFlags?: number): Promise<boolean>;
export declare function ensureDirExists(binHome: string, dirMode?: number, dirFlags?: number): Promise<string>;
export declare function currentOSArch(): Promise<operations["downloadLocalBinary"]["parameters"]["path"]["osArch"] | undefined>;
export declare function saveFile(dirPath: string, filename: string, content: Uint8Array, fileMode: number): Promise<string>;
