import { LocalTestingBinary } from './local-testing-binary.ts';
export * from './index.ts';
export type { LocalBinaryFlags, LocalBinaryFolderTestingFlags, LocalBinaryServerTestingFlags, LocalTestingBinary, LocalTestingBinaryOptions, ProxyParams, } from './local-testing-binary.ts';
/**
 * Represents the BrowserStack API namespace.
 * @namespace
 * @public
 */
export declare const BrowserStack: {
    LocalTestingBinary: typeof LocalTestingBinary;
    AutomateClient: typeof import('./index.ts').AutomateClient;
    ScreenshotsClient: typeof import('./index.ts').ScreenshotsClient;
    AppAutomateClient: typeof import('./index.ts').AppAutomateClient;
    JSTestingClient: typeof import('./index.ts').JSTestingClient;
    Client: typeof import('./index.ts').JSTestingClient;
    LocalTestingClient: typeof import('./index.ts').LocalTestingClient;
};
